/*
Kris looks at the camera

v1.1
*/

local DC = DeltaChars
local Kris = DC.Kris

//Save the slide status
function Kris.SlideSave(player)
	if io and player == consoleplayer and player.kriscameraslide != nil
		local file = io.openlocal("client/DeltaChars/KrisCameraSlide.dat", "w+")
		file:write(player.kriscameraslide)
		file:close()
	end
end

//kriscameraslide command
function Kris.SlideCommand(player, arg, nosave)
	local validcommand = false
	arg = $ and string.lower($)
	if arg == "0" or arg == "default" or arg == "off" or arg == "input"
		player.kriscameraslide = 0
		validcommand = true
	elseif arg == "1" or arg == "on" or arg == "camera"
		player.kriscameraslide = 1
		validcommand = true
	end
	
	if not validcommand
		CONS_Printf(player, "dc_kriscameraslide [on/off] - Sets whether Kris' slide follows the camera when performed or not.")
		if player.kriscameraslide
			CONS_Printf(player, "Currently on.")
		else
			CONS_Printf(player, "Currently off.")
		end
	elseif not nosave
		Kris.SlideSave(player)
	end
end
COM_AddCommand("dc_kriscameraslide", Kris.SlideCommand)
COM_AddCommand("dc_kriscameraslide2", Kris.SlideCommand, COM_SPLITSCREEN)

//Apply the I/O for the command when spawning
function Kris.SlideIO(player)
	//I/O maybe
	if io and player == consoleplayer and player.kriscameraslide == nil
		local file = io.openlocal("client/DeltaChars/KrisCameraSlide.dat")
		if file
			local num = file:read("*n")
			if num
				CommandQueue_Add("dc_kriscameraslide "..num.." s")
			end
			file:close()
		end
	end
end
DC.AddHook("PlayerSpawn", Kris.SlideIO)