/*
Commands to set the colors for each DeltaChar member

v1.1
*/

local DC = DeltaChars

DC.getColor = function(player, skin, menu)
	skin = $ or player.skin
	if not menu and not player.dc_mpcolor and multiplayer return false end
	return player["dc_"..skins[skin].name.."color"] or skins[skin].prefcolor
end

DC.setColor = function(player)
	if not DC.IsDeltaChar(player) then return end
	local color = DC.getColor(player)
	if color
		if player.mo and player.mo.color == player.skincolor
			player.skincolor = color
			player.mo.color = color
		else
			player.skincolor = color
		end
	end
end

DC.saveColors = function(player, mponly)
	if io and player == consoleplayer
		if player.dc_mpcolor != nil
			local file = io.openlocal("client/DeltaChars/MPColor.dat", "w+")
			file:write(player.dc_mpcolor)
			file:close()
		end
		if mponly then return end
				
		for i, skin in ipairs(DC.skins)
			local color = player["dc_"..skin.."color"]
			if color != nil
				local file = io.openlocal("client/DeltaChars/"..skin.."Color.dat", "w+")
				file:write(R_GetNameByColor(color))
				file:close()
			end
		end
	end
end

//dc_mpcolor command
DC.mpcolor = function(player, arg, nosave)
	local validcommand = false
	arg = $ and string.lower($)
	if arg == "0" or arg == "default" or arg == "off"
		player.dc_mpcolor = 0
		validcommand = true
	elseif arg == "1" or arg == "on"
		player.dc_mpcolor = 1
		validcommand = true
	end
	
	if not validcommand
		CONS_Printf(player, "dc_mpcolor [on/off] - Toggles whether DeltaChars colors are applied in multiplayer.")
		if player.dc_mpcolor
			CONS_Printf(player, "Currently on.")
		else
			CONS_Printf(player, "Currently off.")
		end
	elseif not nosave
		DC.saveColors(player, true)
	end
end
COM_AddCommand("dc_mpcolor", DC.mpcolor)
COM_AddCommand("dc_mpcolor2", DC.mpcolor, COM_SPLITSCREEN)

//dc_color command
DC.color = function(player, skin, arg, nosave)
	local validskin = false
	skin = $ and string.lower($)
	arg = $ and string.lower($)
	if skin
		for i, library in ipairs(DC.libraries)
			if skin == library.SKIN
				validskin = true
				break
			end
		end
	end
	
	if validskin and arg
		local color = R_GetColorByName(arg)
		if arg == "0" or arg == "off" or arg == "default"
			player["dc_"..skin.."color"] = skins[skin].prefcolor
			if #skins[skin] == player.skin
				DC.setColor(player)
			end
			
			if io and player == consoleplayer and not nosave
				local file = io.openlocal("client/DeltaChars/"..skin.."Color.dat", "w+")
				file:write(0)
				file:close()
			end
		elseif color and skincolors[color].accessible
			player["dc_"..skin.."color"] = color
			if #skins[skin] == player.skin
				DC.setColor(player)
			end
			
			if io and player == consoleplayer and not nosave
				local file = io.openlocal("client/DeltaChars/"..skin.."Color.dat", "w+")
				file:write(arg)
				file:close()
			end
		else
			CONS_Printf(player, "Invalid color!")
		end
	else
		CONS_Printf(player, "dc_color - Sets the color of a DeltaChars member. First type the skin name then the color name.")
	end
end
COM_AddCommand("dc_color", DC.color)
COM_AddCommand("dc_color2", DC.color, COM_SPLITSCREEN)

//Apply the I/O for the command when spawning
function DC.ColorIO(player)
	//I/O maybe
	if io and player == consoleplayer
		if player.dc_mpcolor == nil
			local file = io.openlocal("client/DeltaChars/MPColor.dat")
			if file
				local num = file:read("*n")
				if num
					CommandQueue_Add("dc_mpcolor "..num.." s")
				end
				file:close()
			end
		end
				
		for i, skin in ipairs(DC.skins)
			local color = player["dc_"..skin.."color"]
			if color == nil
				local file = io.openlocal("client/DeltaChars/"..skin.."Color.dat")
				if file
					local num = file:read("*l")
					if num
						CommandQueue_Add("dc_color "..skin.." "..num.." s")
					end
					file:close()
				end
			end
		end
	end
end
DC.AddHook("PlayerSpawn", DC.ColorIO)