/*
Commands to set the buttons for the swapping and dance

v1.1
*/

local DC = DeltaChars

//String to button
DC.buttonConv1 = {
	["weaponnext"] = BT_WEAPONNEXT,
	["nextweapon"] = BT_WEAPONNEXT,
	["weaponprev"] = BT_WEAPONPREV,
	["prevweapon"] = BT_WEAPONPREV,
	["fire"] = BT_ATTACK,
	["firenormal"] = BT_FIRENORMAL,
	["firen"] = BT_FIRENORMAL,
	["fnormal"] = BT_FIRENORMAL,
	["tossflag"] = BT_TOSSFLAG,
	["custom1"] = BT_CUSTOM1,
	["custom2"] = BT_CUSTOM2,
	["custom3"] = BT_CUSTOM3,
	["c1"] = BT_CUSTOM1,
	["c2"] = BT_CUSTOM2,
	["c3"] = BT_CUSTOM3,
	["none"] = BT_WEAPONMASK,
	["off"] = BT_WEAPONMASK,
}

//Button to string
DC.buttonConv2 = {
	[BT_WEAPONNEXT] = "weaponnext",
	[BT_WEAPONPREV] = "weaponprev",
	[BT_ATTACK] = "fire",
	[BT_FIRENORMAL] = "firenormal",
	[BT_TOSSFLAG] = "tossflag",
	[BT_CUSTOM1] = "custom1",
	[BT_CUSTOM2] = "custom2",
	[BT_CUSTOM3] = "custom3",
	[BT_WEAPONMASK] = "none"
}

//dc_swapnext command
function DC.SwapNext(player, arg, nosave)
	if arg
		if arg == "0" or arg == "default" then arg = "custom1" end
		if DC.buttonConv1[arg] or DC.buttonConv2[tonumber(arg)]
			if DC.buttonConv1[arg]
				player.dc_swapnext = DC.buttonConv1[arg]
			else
				player.dc_swapnext = tonumber(arg)
			end
			
			if io and player == consoleplayer and not nosave
				local file = io.openlocal("client/DeltaChars/SwapNext.dat", "w+")
				file:write(player.dc_swapnext)
				file:close()
			end
		else
			CONS_Printf(player, "Invalid button!")
		end
	else
		CONS_Printf(player, "dc_swapnext - Sets the button to swap to the next DeltaChars character.")
		if not player.dc_swapnext
			CONS_Printf(player, "Currently custom1.")
		elseif not DC.buttonConv2[player.dc_swapnext]
			CONS_Printf(player, "Currently an invalid button!?")
		else
			CONS_Printf(player, "Currently "..DC.buttonConv2[player.dc_swapnext]..".")
		end
	end
end
COM_AddCommand("dc_swapnext", DC.SwapNext)
COM_AddCommand("dc_swapnext2", DC.SwapNext, COM_SPLITSCREEN)

//dc_swapprev command
function DC.SwapPrev(player, arg, nosave)
	if arg
		if arg == "0" or arg == "default" then arg = "custom3" end
		if DC.buttonConv1[arg] or DC.buttonConv2[tonumber(arg)]
			if DC.buttonConv1[arg]
				player.dc_swapprev = DC.buttonConv1[arg]
			else
				player.dc_swapprev = tonumber(arg)
			end
			
			if io and player == consoleplayer and not nosave
				local file = io.openlocal("client/DeltaChars/SwapPrev.dat", "w+")
				file:write(player.dc_swapprev)
				file:close()
			end
		else
			CONS_Printf(player, "Invalid button!")
		end
	else
		CONS_Printf(player, "dc_swapprev - Sets the button to swap to the previous DeltaChars character.")
		if not player.dc_swapprev
			CONS_Printf(player, "Currently custom3.")
		elseif not DC.buttonConv2[player.dc_swapprev]
			CONS_Printf(player, "Currently an invalid button!?")
		else
			CONS_Printf(player, "Currently "..DC.buttonConv2[player.dc_swapprev]..".")
		end
	end
end
COM_AddCommand("dc_swapprev", DC.SwapPrev)
COM_AddCommand("dc_swapprev2", DC.SwapPrev, COM_SPLITSCREEN)

//dc_dance command
function DC.Dance(player, arg, nosave)
	if arg
		if arg == "0" or arg == "default" then arg = "custom2" end
		if DC.buttonConv1[arg] or DC.buttonConv2[tonumber(arg)]
			if DC.buttonConv1[arg]
				player.dc_dance = DC.buttonConv1[arg]
			else
				player.dc_dance = tonumber(arg)
			end
			
			if io and player == consoleplayer and not nosave
				local file = io.openlocal("client/DeltaChars/Dance.dat", "w+")
				file:write(player.dc_dance)
				file:close()
			end
		else
			CONS_Printf(player, "Invalid button!")
		end
	else
		CONS_Printf(player, "dc_dance - Sets the button used to dance as DeltaChars.")
		if not player.dc_dance
			CONS_Printf(player, "Currently custom2.")
		elseif not DC.buttonConv2[player.dc_dance]
			CONS_Printf(player, "Currently an invalid button!?")
		else
			CONS_Printf(player, "Currently "..DC.buttonConv2[player.dc_dance]..".")
		end
	end
end
COM_AddCommand("dc_dance", DC.Dance)
COM_AddCommand("dc_dance2", DC.Dance, COM_SPLITSCREEN)

function DC.SwapSave(player)
	if io and player == consoleplayer
		local file
		if player.dc_swapnext
			file = io.openlocal("client/DeltaChars/SwapNext.dat", "w+")
			file:write(player.dc_swapnext)
			file:close()
		end
		
		if player.dc_swapprev
			file = io.openlocal("client/DeltaChars/SwapPrev.dat", "w+")
			file:write(player.dc_swapprev)
			file:close()
		end
		
		if player.dc_dance
			file = io.openlocal("client/DeltaChars/Dance.dat", "w+")
			file:write(player.dc_dance)
			file:close()
		end
	end
end

//Apply the I/O for the command when spawning
function DC.SwapIO(player)
	//I/O maybe
	if io and player == consoleplayer
		if player.dc_swapnext == nil
			local file = io.openlocal("client/DeltaChars/SwapNext.dat")
			if file
				local num = file:read("*n")
				if num
					CommandQueue_Add("dc_swapnext "..num.." s")
				end
				file:close()
			end
		end
		
		if player.dc_swapprev == nil
			local file = io.openlocal("client/DeltaChars/SwapPrev.dat")
			if file
				local num = file:read("*n")
				if num
					CommandQueue_Add("dc_swapprev "..num.." s")
				end
				file:close()
			end
		end
		
		if player.dc_dance == nil
			local file = io.openlocal("client/DeltaChars/Dance.dat")
			if file
				local num = file:read("*n")
				if num
					CommandQueue_Add("dc_dance "..num.." s")
				end
				file:close()
			end
		end
	end
end
DC.AddHook("PlayerSpawn", DC.SwapIO)